import 'package:json_annotation/json_annotation.dart';

part 'refresh.g.dart';

@JsonSerializable()
class RefreshRequest {
  final String accessToken;
  final String clientToken;
  final SelectedProfile? selectedProfile;
  final bool? requestUser;

  RefreshRequest(
      {required this.accessToken,
      required this.clientToken,
      this.selectedProfile,
      this.requestUser = true});
  factory RefreshRequest.fromJson(Map<String, dynamic> json) =>
      _$RefreshRequestFromJson(json);
  Map<String, dynamic> toJson() => _$RefreshRequestToJson(this);
}

@JsonSerializable()
class RefreshResponse {
  final String accessToken, clientToken;
  final SelectedProfile? selectedProfile;
  final User user;

  RefreshResponse(
      {required this.accessToken,
      required this.clientToken,
      this.selectedProfile,
      required this.user});
  factory RefreshResponse.fromJson(Map<String, dynamic> json) =>
      _$RefreshResponseFromJson(json);
  Map<String, dynamic> toJson() => _$RefreshResponseToJson(this);
}

@JsonSerializable()
class SelectedProfile {
  final String id, name;

  SelectedProfile({required this.id, required this.name});
  factory SelectedProfile.fromJson(Map<String, dynamic> json) =>
      _$SelectedProfileFromJson(json);
  Map<String, dynamic> toJson() => _$SelectedProfileToJson(this);
}

@JsonSerializable()
class User {
  final String username, id;
  final List<Property>? properties;

  User({required this.username, required this.id, this.properties});
  factory User.fromJson(Map<String, dynamic> json) => _$UserFromJson(json);
  Map<String, dynamic> toJson() => _$UserToJson(this);
}

@JsonSerializable()
class Property {
  final String name, value;

  Property(this.name, this.value);
  factory Property.fromJson(Map<String, dynamic> json) =>
      _$PropertyFromJson(json);
  Map<String, dynamic> toJson() => _$PropertyToJson(this);
}
